#include <stdio.h>
#include <stdlib.h>
#include <inttypes.h>

#define MAXN 10000
#define ll int64_t
#define ull uint64_t

ll nums[MAXN];
ull n;

ll getActualIdx(ll idx, ll shift) {
    ll raw = idx - shift;
    if (raw >= 0 && raw < n) {
        return raw;
    }
    if (raw < 0) {
        while (raw < 0) {
            raw = n + raw;
        }
        return raw;
    }
    else {
        return raw % n;
    }
}


int main() {
    ull q;
    int cmd;
    ll x, sum, diff, k, shift, idx;

    sum = 0;
    shift = 0;

    scanf("%" SCNu64, &n);
    for (size_t i = 0; i < n; ++i) {
        scanf("%" SCNd64, &nums[i]);
        sum += *(nums + i);
    }

    scanf("%" SCNu64, &q);
    for (size_t i = 0; i < q; ++i) {
        scanf("%d", &cmd);

        if (cmd == 1) {
            scanf("%" SCNd64 " %" SCNd64, &idx, &x);
            idx--;
            diff = x - nums[getActualIdx(idx, shift)];
            sum += diff;
        }
        else {
            scanf("%" SCNd64, &k);
            shift += k;
        }
        printf("%" PRId64 "\n", sum);
    }

    return 0;
}
